/*
dline - dashed line version of 'line'
*/

#ident "$Id: dline.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"

#include <math.h>
#include "crcplot.h"

void dline(x,y,n,dsh,gap,m)
float *x;	/*x vector*/
float *y;       /*y vector*/
int n;       /*size(x) = size(y)*/
float *dsh;	     /*vector of dashes*/
float *gap;     /*vector of gaps*/
int m;       /*size(dsh) = size(gap)*/
{
        float len,lenl,nx,ny;
        int i,lp,dshgap,sp;
	float xn,yn,at,xn1,yn1,xs=-1,ys=-1,dx,dy,xn1i,yn1i;
/*
c
c       init scale factors and loop pointers
c
*/
	plots_open_check("dline");

	dsh--; gap--; x--; y--;
        lenl = dsh[1];
        dshgap = 0;
        sp = 0;
        lp = 1;
        xn = x[n+1];
        xn1 = x[n+2];
        yn = y[n+1];
        yn1 = y[n+2];
        xn1i = xn1;
        yn1i = yn1;
        xn1 = 1.0 / xn1;
        yn1 = 1.0 / yn1;
/*
        plot to first point
*/
        plot((x[1]-xn)*xn1,(y[1]-yn)*yn1,3);
        i = 2;
/*
	loop through all the points; fake extra points due to gap/dash spacing
*/
	while(i <= n){

        dx = (x[i] - x[i-1]) * xn1;     /*see how long next line is*/
        dy = (y[i] - y[i-1]) * yn1;
        len = sqrt(dx*dx + dy*dy);

        if(len > lenl){ /*length is more than length of current dash gap*/
		at = lenl / len;
                nx = dx * at;
                ny = dy * at;
                plot((x[i-1]-xn)*xn1+nx,(y[i-1]-yn)*yn1+ny,2+dshgap);
                if(dshgap != 1){
                        dshgap = 1;
                        lenl = gap[lp];
                }else{
			dshgap = 0;
                        lp = lp + 1;
                        if(lp > m)lp = 1;
                        lenl = dsh[lp];
                }
		if(sp == 0){
                        xs = x[i-1];
                        ys = y[i-1];
                        sp = 1;
                }
		x[i-1] = x[i-1] + nx*xn1i;
                y[i-1] = y[i-1] + ny*yn1i;
                i = i - 1;
        }else{ 		/*length is < length of current dash gap*/
                plot((x[i]-xn)*xn1,(y[i]-yn)*yn1,2+dshgap);
                if(sp != 0){
                        x[i-1] = xs;
                        y[i-1] = ys;
                        sp = 0;
                }
		lenl = lenl - len;
                if(lenl <= 0.0){
                        if(dshgap != 1){
                                dshgap = 1;
                                lenl = gap[lp];
                        }else{
				dshgap = 0;
                                lp = lp + 1;
                                if(lp > m) lp = 1;
                                lenl = dsh[lp];
			}
                }
	}

	i = i + 1;
    }
}
