/*	
	ex13.c - demonstrates cplot
*/
#ident "$Id: ex13.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"
#include <math.h>
#include <crcplot.h>
#include <unistd.h>
#include <stdlib.h>
#include <parse.h>

static void
cmdout(cmd)
char *cmd;
{
	fputs(cmd,stderr);
	fputs("\n",stderr);
	system(cmd);
}

#define N 64

int
main()
{
	int i,j,k;
	float sx,sy,x,y,z[N*N];
	char *cmd;
/*
	generate data and save in external file
*/
	for(k=i=0;i<N;i++){	
		y = (i - N/2.) / N * M_PI * 7.0;
		if(i == N/2) sy = 1.0;
		else sy = fabs(sin(y)/y);
		for(j=0;j<N;j++){	
			x = (j - N/2.) / N * M_PI * 7.0;
			if(j == N/2) sx = 1.0;
			else sx = fabs(sin(x)/x);
			z[k++] = sx * sy;
		}
	}
	parse_wda(z,N,N,"sinc");
/*
	simulation prompt invocation of cplot
*/
	cmd = "../plot/cplot -@ z=sinc,d -f xl=sinc\\(x\\)";
	cmdout(cmd);
/*
	clean up
*/
	unlink("sinc.da");
	exit(0);
}

