/*	
	ex14.c - demonstrates plot3d
*/
#ident "$Id: ex14.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"
#include <math.h>
#include <unistd.h>
#include <stdlib.h>
#include <crcplot.h>
#include "parse.h"

#define N 64

static void
cmdout(cmd)
char *cmd;
{
	fputs(cmd,stderr);
	fputs("\n",stderr);
	system(cmd);
}

int
main()
{
	int i,j,k;
	float sx,sy,x,y,z[N*N];
	char *cmd;
/*
	generate data and save in external file
*/
	for(k=i=0;i<N;i++){	
		y = (i - N/2.) / N * M_PI * 7.0;
		if(i == N/2) sy = 1.0;
		else sy = fabs(sin(y)/y);
		for(j=0;j<N;j++){	
			x = (j - N/2.) / N * M_PI * 7.0;
			if(j == N/2) sx = 1.0;
			else sx = fabs(sin(x)/x);
			z[k++] = sx * sy;
		}
	}
	parse_wda(z,N,N,"sinc");
/*
	simulation prompt invocation of plot3d
*/
	cmd = "../plot/plot3d -@ z=sinc,d zl=sinc\\(x\\) dir=xy skip=1 scale=.8";
	cmdout(cmd);
/*
	clean up
*/
	unlink("sinc.da");
	exit(0);
}
