/*
grid - generate grid patterns
*/

#ident "$Id: grid.c,v 1.4 2007/05/22 15:33:04 ccrawford Exp $"

#include <stdlib.h>
#include "crcplot.h"

void grid(x,y,nx,xd,ny,yd)
double x,y;	/* lower left corner of grid */
int nx,ny;	/* number of points, abs>1000->array, <0->invisible */
float *xd,*yd;	/* arrays of distances */
{
	float x1,x2,y1,y2;
	int ax,ay;
	int hor,ver;
	int i;
/*
	check for visibility and arrays
*/
	plots_open_check("grid");

	hor = ny > 0;
	ver = nx > 0;
	nx = abs(nx);
	ny = abs(ny);
	ax = nx / 1000;
	ay = ny / 1000;
	nx = nx - ax*1000;
	ny = ny - ay*1000;
/*
	check for null grids
*/
	if(nx <= 0 || ny <= 0)return;
/*
	get horizontal extent
*/
	x2 = x1 = x;
	for(i=0;i<nx;i++) x2 += xd[i*ax];
/*
	plot horizontal lines
*/
	if(hor){
		y1 = y;
		plot(x1,y1,3);
		plot(x2,y1,2);
		for(i=0;i<ny;i++){
			y1 += yd[ay*i];
			plot(x1,y1,3);
			plot(x2,y1,2);
		}
	}
/*
	get vertical extent
*/
	y2 = y1 = y;
	for(i=0;i<ny;i++) y2 += yd[i*ay];
/*
	plot vertical lines
*/
	if(ver){
		x1 = x;
		plot(x1,y1,3);
		plot(x1,y2,2);
		for(i=0;i<nx;i++){
			x1 += xd[i*ax];
			plot(x1,y1,3);
			plot(x1,y2,2);
		}
	}
}
