/*
line - plot points from coordinate data arrays
*/

#ident "$Id: line.c,v 1.4 2007/05/22 15:33:04 ccrawford Exp $"

#include <stdlib.h>
#include "crcplot.h"

void line(x,y,n,inc,type,sym)
float *x,*y;		/* line coordinates */
int n;			/* number of coordinates to plot */
int inc;		/* stride between points in x/y */
int type;		/* =0, line no symbols
			   +type, lines & symbols every type 
			   -type, no lines & symbols every type */
int sym;		/* sym # (see symbol.c) for type != 0 */
{
	float dx,dy;		/* scale factor coordinates to plot */
	float xmin,ymin;	/* min values in arrays */
	int m;			/* abs(type) */
	int ns;			/* running count of points plotted mod m */
	int scode;		/* code to use in call to symbol */
	int pud;		/* pen up/down for plot call */
	int i;			/* counter for for loop */
	float xp,yp;		/* coordinate in plot units */
/*
	initialization
*/
	plots_open_check("line");

	pud = 3;
	ns = m = abs(type);
	scode = -1;

	xmin = x[n * inc];
	dx = x[(n+1) * inc];
	ymin = y[n * inc];
	dy = y[(n+1) * inc];
/*
	do it
*/
	for(i=0;i<n;i++){
		xp = (x[i*inc] - xmin) / dx;
		yp = (y[i*inc] - ymin) / dy;

		if(type != 0 && ns == m){
			symbol(xp,yp,.08,(char *)sym,0.0,scode);
			scode = (type > 0)? -2 : -1;
			ns = 0;
		}else if(type >= 0){
			plot(xp,yp,pud);
		}
		ns++;
		pud = 2;
	}
}
