/*
plot - draw vectors as part of crc plot package
*/

#ident "$Id: plot.c,v 1.3 2007/05/22 15:33:04 ccrawford Exp $"

#include <stdio.h>
#include "crcplot.h"

void exit();

#define NDEL 32767	/* x resolution */
#define NDLIN 32767	/* y resolution */

static int ud;		/* pen up/down 0=up 1=down (see vinc) */
static float ipszx;	/* number of pixels per unit - x */
static float ipszix;	/* 1 / ipszx - x */
static float ipszy;	/* numer of pixels per unit - y */
static float ipsziy;	/* 1 / ipszy - y */
static float xo;	/* x-origin */
static float yo;	/* y-origin */
static float axp;	/* actual x-position */
static float ayp;	/* actual y-position */
static int crc_x0;	/* int version of x-position */
static int crc_y0;	/* int version of y-position */
static float scfac;	/* scale factor */

void 
plot(x,y,i)
double x;	/*plot to this x value*/
double y;	/*plot to this y vaue*/
int i;		/*pen/origin flag*/
{
	float xx,yy;
	int m,l;

/*
	check for open plotter
*/
	plots_open_check("plot");
/*
	handle mode=999 - clean up
*/
        if(i == 999){
		plots_close();
        	plot_closepl();
        	return;
	}
/*
	handle normal plotting commands
*/
	if(i < -3 || i > 3){
		fprintf(stderr, "plot: illegal mode: %d\n",i);
		exit(1);
	}
	if(i == 2 || i == -2 ) ud = 1;	/* pen up */
	if(i == 3 || i == -3 ) ud = 0;	/* pen down */

	xx = x * scfac;
        yy = y * scfac;

        l = ((int) ((xx + xo)*ipszx + 0.5)) - crc_x0;
        m = ((int) ((yy + yo)*ipszy + 0.5)) - crc_y0;

	if(ud == 1){
		plot_cont(l + crc_x0, m + crc_y0);
	}else{
		plot_move(l + crc_x0, m + crc_y0);
	}
	crc_x0 = crc_x0 + l;
	crc_y0 = crc_y0 + m;
        axp = xo + xx;
        ayp = yo + yy;

        if(i <= 0){
		xo = axp;
		yo = ayp;
	}
}


void
plotinit_()
{
	plot_space(0,0,NDEL,NDLIN);
        ipszx = (NDEL-1.) / 10.0;
        ipszix = 1.0 / ipszx;
        ipszy = (NDLIN-1.) / 10.0;
        ipsziy = 1.0 / ipszy;

        xo = 0;          /*x-origin*/
        yo = 0;         /*y-origin*/
        axp = 0;        /*actual x-position*/
        ayp = 0;       /*actual y-position*/
        crc_x0 = 0;      /*integer x-position*/
        crc_y0 = 0;          /*integer y-position*/
        ud = 0;          /*pen position (up)*/
        scfac = 1;       /*scale factor*/
}

void
plotfactor_(x)
float x;
{
	scfac = x;
}

void
plotwhere_(x,y,sf)
float *x;          /*x-position*/
float *y;          /*y-position*/
float *sf;         /*scale factor*/
{
        *x = axp - xo;
        *y = ayp - yo;
        *sf = scfac;
}

void
plot_warp_(xp,yp,x,y)
int xp,yp;
float *x,*y;
{

	/*
        l = ((int) ((xx + xo)*ipszx + 0.5)) - crc_x0;
        m = ((int) ((yy + yo)*ipszy + 0.5)) - crc_y0;
	xx = x * scfac;
        yy = y * scfac;
	*/

	*x = (xp/ipszx - xo)/scfac;
	*y = (yp/ipszy - yo)/scfac;
}
