/*
parse_args_proc - parse enviromental string using proc
*/

#ident "$Id: args.c,v 1.4 2007/05/22 15:51:51 ccrawford Exp $"

#include "parse.h"
#include <string.h>
#include <stdlib.h>

#define MA 256 		/* max # arguments */

int 
parse_args_proc (
    struct PARSE_STRUCT *options,
    struct PARSE_FLAG_TABLE *flags,
    FILE *fd,
    char *arg,
    int (*proc)(),
    int proc_type		/* 0=argc/argv 1= + strucutures */
)
{
	char *argv[MA];
	int argc;
	char *e,*s,*p;

	if((e=getenv(arg)) == NULL)return(0);
	s = parse_malloc_char(strlen(e)+1);
	strcpy(s,e);

	argc = 1;
	while(*s){
		if(argc >= MA-1){
			fputs("parse_args: too many arguments\n",fd);
			return(-1);
		}
		while(*s == ' ')*s++ = 0;
		if(*s){
			if(*s != '"')argv[argc++] = s;
			else{
				argv[argc++] = ++s;
				while(*s){
					if(*s != '"')s++;
					else{
						*s++ = 0;
						break;
					}
				}
			}
		}
		while( (*s != ' ')  && *s){
			if(*s != '"')s++;
			else{
				p = s;
				while(*p){
					*p = *(p+1);
					p++;
				}
				while(*s){
					if(*s != '"')s++;
					else{
						*s++ = 0;
						break;
					}
				}
			}
		}
	}
	if(argc > 1){
		switch(proc_type){

		case 0:
			return( (*(int (*)(int,char **)) (proc)) (argc,argv));
		case 1:
			return( 
			(* (int (*)
			    (
			    struct PARSE_STRUCT *,
			    struct PARSE_FLAG_TABLE *,
			    FILE *,
			    int ,
			    char **) )
			(proc)) (options,flags,fd,argc,argv));
		default:
			parse_err("parse_args_proc: illegal proc type","");
		}
	}
	return(0);
}
