/*
buffer - work on buffers
*/

#ident "$Id: buffer.c,v 1.5 2007/05/22 15:51:51 ccrawford Exp $"

#include <math.h>
#include "parse.h"

void 
parse_zbuf (short int *a, int n)
{
	register int i;

	for(i=0;i<n;a[i++] = 0);
	return;
}

void 
parse_zsbuf (short int *a, int n)
{
	register int i;

	for(i=0;i<n;a[i++] = 0);
	return;
}

void 
parse_zibuf (int *a, int n)
{
	register int i;

	for(i=0;i<n;a[i++] = 0);
	return;
}

void 
parse_zrbuf (float *a, int n)
{
	register int i;

	for(i=0;i<n;a[i++] = 0.0);
}

void 
parse_zfbuf (float *a, int n)
{
	register int i;

	for(i=0;i<n;a[i++] = 0.0);
}

void 
parse_dami (float *a, short int *mi, int n, int m)
{
	int n2,i;
	float amin,amax,at;
	float zero=1024;	/* number where zero will land */
	float scale=128;	/* scale (range) of output */

	n2 = n * m;
	amin = amax = a[0];
	for(i=0;i<n2;i++){
			at = a[i];
			if(at > amax) amax = at;
			if(at < amin) amin = at;
	}

	if(amin == amax){
		parse_prf("parse_dami (warning): min = max =",amin);
		amax = amin + 1;
	}

	amax = fabs(amax);
	amin = fabs(amin);
	amax = (amax > amin)? amax : amin;
	amin = -amax;
	zero = zero - scale/2;
	scale = scale / (amax - amin);
	for(i=0;i<n2;i++) mi[i] = (int) ((a[i] - amin) * scale + zero);
}
