/*
general - "basic" parser interface with arg'ed structures

parse_general - parse argc/argv structure using predefined structures
parse_file_general - parse initialization file using parse_basic
parse_args_general - parse enviromental string using parse_basic
parse_help_general - print help from option/flag structures
*/

#ident "$Id: general.c,v 1.5 2007/05/22 15:51:51 ccrawford Exp $"

#include "parse.h"

int 
parse_general (struct PARSE_OPTION_TABLE *options, struct PARSE_FLAG_TABLE *flags, FILE *fd, int argc, char **argv)
{
	while(argv++,--argc){
		if(**argv == '-'){
			if(-1 == parse_fflags(flags,*argv,fd))return(-1);
		}else{
			if(-1 == parse_pparse_aa(options,fd,&argc,&argv)) 
				return(-1);
		}
	}
	return(0);
}

int 
parse_file_general (struct PARSE_OPTION_TABLE *options, struct PARSE_FLAG_TABLE *flags, FILE *fd, char *file)
{
	return(parse_file_proc(options,flags,fd,file,(int(*)()) parse_general,1,0,1));
}

int 
parse_args_general (struct PARSE_OPTION_TABLE *options, struct PARSE_FLAG_TABLE *flags, FILE *fd, char *arg)
{
	return(parse_args_proc(options,flags,fd,arg,(int (*)()) parse_general,1));
}

void 
parse_help_general (struct PARSE_OPTION_TABLE *options, struct PARSE_FLAG_TABLE *flags, FILE *fd)
{
	parse_flag_help(flags,fd);
	parse_option_help(options,fd);
}
