/*
input - read vectors for qplot
*/

#ident "$Id: input.c,v 1.5 2007/05/22 15:54:48 ccrawford Exp $"

#include <stdio.h>
#include <parse.h>
#include "qplot.h"

int 
input(name,vec,begin,skip,count)
char *name;      /*input file name*/
float **vec;             /*final vector*/
int begin;           /*first point to be used*/
int skip;            /*number of points between used points*/
int count;           /*maximum number of points to be read*/
{
	short int head[256];
        float *fvec;           
	FILE *fd;
	int loop,ir,ibs,n,k,ibyte,nbr,ib,ip,iblk,ll,i;
/*
	open input file
*/
        name = parse_suffix_malloc(name,"da");
        fd = parse_fopen(name,"r");
/*
	get header information
*/
        parse_rblock(fd,0,(char *)head,1);
        parse_from_can_shortv(head,256);

        n = head[0];             
        k = head[1];             
        ibyte = head[2];         

        if(n <= 0) parse_err("qplot: improper column count: ",name);
        if(k <= 0) parse_err("qplot: improper row count: ",name);
        if(ibyte != 0) parse_err("qplot: only float da-files allowed: ",name);

	nbr = BLOCK_FLOAT(n); 
	fvec = (float *)parse_malloc(nbr*512);
/*
	set up record dependent information
*/
        ibs = 0;                 /*# of records to skip*/
        if(begin < 0){
		if(-begin >= k) parse_err("qplot: begin too large: ",name);
		ibs = -begin;
		begin = 0;
	}
	if(skip < 0)parse_err("bad skip value","");
        if(count < 0){
                count = -count * n;
                if(begin > 0)count = count - begin;
                count = count / (skip+1);
        }
/*
	get to start of file
*/
        ib = begin;
        ir = ib / n;                     /*number of records to skip*/
        ip = ib - ir * n + 1;            /*position first real record*/
        iblk = (ibs+ir) * nbr + 1;       /*start of first blocks to read*/

	parse_rblock(fd,iblk,(char *)fvec,nbr);	 /*get first record of data*/
        iblk = iblk + nbr;

	parse_from_can_floatv(fvec,n);
/*
	read actual points
*/
        ll = 0;
	loop = 1;
	block_init(1);
	while(loop){
		for(i=0;i<=skip;i++){
			if(ip > n){
				parse_rblock(fd,iblk,(char *)fvec,nbr);
				iblk += nbr;
				ip = 1;
				parse_from_can_floatv(fvec,n);
			}

			if(!i){
				ll++;
				block_add(fvec[ip-1],0.0);
				if(ll == count){
					loop = 0;
					break;
				}
			}
			ip++;
		}
	}

	parse_free(name);
	parse_free((char *)fvec);
	if(ll != block_flush(vec,(float **)NULL))
		parse_err("qplot: internal error: block mismatch","");
	if(!ll) parse_err("qplot: no points read from: ",name);
        return(ll);
}
