/*
inputa - input ascii vectors for qplot
*/

#ident "$Id: inputa.c,v 1.5 2007/05/22 15:54:48 ccrawford Exp $"

#include <stdio.h>
#include <parse.h>
#include <stdlib.h>
#include "qplot.h"

#define MWORD 200	 /*max # words on a line*/

int
inputa(xf,yf,cxyf,cxym,xd,yd,begin,skip,count,nx,ny,usey)
char *xf;		/*x-file name*/
char *yf;		/*y-file name*/
char *cxyf;		/*combined xy-file*/
int cxym;		/*1=combined xy-data mode*/
float **xd;		/*x-data vector*/
float **yd;		/*y-data vector*/
int begin;		/*start of data*/
int skip;		/*# points to skip after read*/
int count;		/*number of points to read*/
int nx;			/*x-position*/
int ny;			/*[relative] y-position*/
int usey;		/*1=use only y-file*/
{
        char s[PARSE_MAX_LINE];	/*line from input files*/
        char *argv[MWORD];	/*pointers to words*/
        int argc;		/*# words found on a line*/
	int iy;			/*number of points returned*/
	FILE *fd,*fdx=NULL;
	int isb,i,loop;
	float xtmp=-1,ytmp;
/*
	open files
*/
        if(cxym != 1){
		yf = parse_suffix_malloc(yf,"as");
		fd = parse_fopen(yf,"r");
		parse_free(yf);
		if(usey == 0){
			xf = parse_suffix_malloc(xf,"as");
			fdx = parse_fopen(xf,"r");
			parse_free(xf);
		}
	}else{
		cxyf = parse_suffix_malloc(cxyf,"as");
		fd = parse_fopen(cxyf,"r");
		parse_free(cxyf);
	}
/*
	init parameters
*/
        if(cxym == 1)usey = 0;
        iy = 0;
/*
	loop through reads
*/
	block_init( (cxym || !usey)? 2 : 1);
	loop = 1;
	while(loop){
		if(loop == 1){
			isb = begin;             
			loop = 2;
		}else{
			isb = skip;
		}

		for(i=0;i<isb;i++){	/* handle skip and begin */
			if(parse_urline(fd,s))goto exit;
			if(usey == 0 && cxym == 0){
				if(parse_urline(fdx,s))goto exit;
			}
		}

		if(parse_urline(fd,s))goto exit;
		if(iy == count)goto exit;

		parse_words(s,&argc,argv,MWORD);

		if(cxym == 0){
			if(ny < 0 || ny > argc)goto exit;
			ytmp = atof(argv[ny-1]);
			if(usey == 0){
				if(parse_urline(fdx,s))goto exit;
				parse_words(s,&argc,argv,MWORD);
				if(nx < 0 || nx > argc)goto exit;
				xtmp = atof(argv[nx-1]);
			}
		}else{
			if(nx+ny < 0 || nx + ny > argc)goto exit;
			if(nx < 0 || nx > argc)goto exit;
			xtmp = atof(argv[nx-1]);
			ytmp = atof(argv[nx+ny-1]);
		}
		block_add(ytmp,xtmp);
		iy++; 
		if(count >0 && iy >= count) break;
	}
/*
	clean up and return
*/
exit:
	if(iy <= 0)parse_err("qplot (inputa): no points read from input file(s)","");
        parse_fclose(fd);
        if(usey == 0 && cxym == 0)parse_fclose(fdx);

	if(iy != block_flush(yd,xd))
		parse_err("qplot (block): internal error: block mismatch","");
	return(iy);
}
