/*
plotps - main program to convert plot(5) to ps - replaces transcipt's version
*/

#ident "$Id: plotps.c,v 1.6 2007/05/22 15:54:48 ccrawford Exp $"

#include <stdio.h>
#include <math.h>
#include "parse.h"
#include "crcplot.h"
#include "crcplot_config.h"

static int scaleps = SCALE_D;
static int eps;
static int rot;
float plot_ho=HOR,plot_vo=VER;
static char *ifn;
static float bbx=1.0;
static float bby=1.0;

static void ifn_proc(char *f);

struct PARSE_STRUCT parse_table[] = {
	{"scale",PARSE_INT,(PARSE_ARG)&scaleps,"percent of full size"},
	{"hor",PARSE_FLOAT,(PARSE_ARG)&plot_ho,"horizontal offset (inches)"},
	{"ver",PARSE_FLOAT,(PARSE_ARG)&plot_vo,"vertical offset (inches)"},
	{"bbx",PARSE_FLOAT,(PARSE_ARG)&bbx,"x bounding box scale"},
	{"bbx",PARSE_SET,(PARSE_ARG)&eps},
	{"bby",PARSE_FLOAT,(PARSE_ARG)&bby,"y bounding box scale"},
	{"bby",PARSE_SET,(PARSE_ARG)&eps},
	{"=",PARSE_CHAR,(PARSE_ARG)&ifn,"input file (default stdin)"},
	{"?",PARSE_PROC,(PARSE_ARG)parse_help_basic},
	{0,0,0,0}
	};

struct PARSE_FLAG_TABLE parse_flag_table[] = {
	{'e',&eps,PARSE_FLAG_SET,"encapsulated postscript"},
	{'s',&eps,PARSE_FLAG_SET,"encapsulated + xplot/sunplot buffer"},
	{'s',(int *)ifn_proc,PARSE_FLAG_PROC},
	{'x',&eps,PARSE_FLAG_SET,"encapsulated + xplot/sunplot buffer"},
	{'x',(int *)ifn_proc,PARSE_FLAG_PROC},
	{'S',(int *)ifn_proc,PARSE_FLAG_PROC,"xplot/sunplot buffer"},
	{'X',(int *)ifn_proc,PARSE_FLAG_PROC,"xplot/sunplot buffer"},
	{'l',&rot,PARSE_FLAG_SET,"landscape (rotated) output"},
	{'p',&rot,PARSE_FLAG_CLR,"portrait output"},
	{'?',(int *)parse_help_basic,PARSE_PROC},
	{0,0,0,0}
};

static void ifn_proc(f)
char *f;
{
	ifn = PLOTNAME;
}

int
main(argc,argv)
int argc;
char **argv;
{
	FILE *fd;

	parse_all_basic(".plotps","PLOTPSARGS",argc,argv);

	if(ifn){
		if((fd = fopen(ifn,"r")) == NULL){
			fprintf(stderr,"Can't open: %s\n",PLOTNAME);
			exit(1);
		}
	}else{
		fd = stdin;
	}

	if(eps){
		plot_ho = bbx;
		plot_vo = bby;
	}
	plot_tops(fd,stdout,scaleps,eps,rot,plot_ho,plot_vo);
	return(0);
}

