/*
daas - convert da files to ascii
*/

static char rcsid[] = "$Id: daas.c,v 1.8 2005/03/29 21:01:11 ccrawford Exp $";

#include "parse.h"

static int print;		/*flag for printing program info*/
static char *ofn;		/*output filename*/
static int ofns;		/*output file name set*/
static char *ifn="y.da";	/*input filename*/
static int num;			/*1=number output*/

struct PARSE_OPTION_TABLE parse_table[] = {
	{"if",PARSE_CHAR,(PARSE_ARG)&ifn,"input file"},
	{"=",PARSE_CHAR,(PARSE_ARG)&ifn,"if"},
	{"of",PARSE_CHAR,(PARSE_ARG)&ofn, "output file (default stdout)"},
	{"of",PARSE_SET,(PARSE_ARG)&ofns},
	{"?",PARSE_PROC,(PARSE_ARG)parse_help_basic},
	{0,0,0,0}
};

struct PARSE_FLAG_TABLE parse_flag_table[] = {
	{'n',&num,PARSE_FLAG_SET,"number output"},
	{'p',&print,PARSE_FLAG_CLR,"don't print program information"},
	{'?',(int *)(parse_help_basic),0,0},
	{0,0,0,0}
};

int
main(argc,argv)
	int argc;
	char **argv;
{
	int *ivr;
	short int head[256];
	FILE *ifd,*ofd;
	int nblki,iblki,type,i,j,n,m;

	parse_basic(argc,argv);
/*
	open files
*/
        ifn = parse_suffix_malloc(ifn,"da");
        ifd = parse_fopen(ifn,"r");

	if(ofns){
		ofn = parse_suffix_malloc(ofn,"as");
		ofd = parse_fopen(ofn,"w");
	}else{
		ofd = stdout;
	}
/*
	header information
*/
        parse_rblock(ifd,0,(char *)head,1);
        parse_from_can_shortv(head,256);
        n = head[0];
        m = head[1];
        type = head[2];
        if(type)parse_err("daas: can't handle integer da files:",ifn);
/*
	get internal vector(s)
*/
	ivr = parse_malloc_int(BLOCK_FLOAT(n)*128);
/*
	print program status
*/
	if(print){
		parse_wtext("****************** daas *********************");
		parse_pdt("---> start time");
		parse_rcsid_print(rcsid);
		parse_prs("input file:",ifn);
		if(ofns)parse_prs("output file:",ofn);
		parse_pri("da-file record size:",n);
		parse_pri("da-file records:",m);
	}
/*
	compute record information
*/
	nblki = BLOCK_FLOAT(n);
        iblki = 1;
/*
	read input records and send them to the output file
*/
	for(i=0;i<m;i++){
		parse_rblock(ifd,iblki,(char *)ivr,nblki);
		iblki += nblki;
		for(j=0;j<n;j++){
			if(num){
				if(m > 1)
					fprintf(ofd,"%d %d ",i,j);
				else
					fprintf(ofd,"%d ",j);
			}
			fprintf(ofd,"%f\n",parse_from_can_float(ivr[j]));
		}
	}
/*
	clean up and exit
*/
        if(print)parse_pdt("---> stop time");
	exit(0);
}
