/*
canvas - routines to transfer image storage to canvas
*/

#ident "$Id: canvas.c,v 1.8 2007/05/22 13:22:45 ccrawford Exp $"

#include "xpic.h"

void
load_pix(int area)
{
	int i;
	register int j;
	DPIXEL8 *image8;
	DPIXEL8 *ip8;
	DPIXEL32 *image32;
	DPIXEL32 *ip32;
	CPIXEL *mip;
	int offset;
	int rx,ry,rdx,rdy;	
	int load_display;
	int subregion;
	int annotate;

/*
	set up for load
*/
	if(box.vis) draw_box(LINE_SOFT);

	switch(area){

	case -1:
		rx = 0;
		ry = 0;
		rdx = canvas_size_x;
		rdy = canvas_size_y;
		annotate = 0;
		load_display = 1;
		subregion = 0;
		break;
	case 0:
		rx = 0;
		ry = 0;
		rdx = canvas_size_x;
		rdy = canvas_size_y;
		annotate = 1;
		load_display = 1;
		subregion = 0;
		break;
	case 1:
		rx = da_x;
		ry = da_y;
		rdx = da_xw;
		rdy = da_yw;
		annotate = 1;
		load_display = 1;
		subregion = 1;
		break;
	case 2:
		rx = da2_x;
		ry = da2_y;
		rdx = da2_xw;
		rdy = da2_yw;
		annotate = 1;
		load_display = 1;
		subregion = 1;
		break;
	case 3:
		rx = 0;
		ry = 0;
		rdx = canvas_size_x;
		rdy = canvas_size_y;
		annotate = 1;
		load_display = 0;
		subregion = 0;
		break;
	default:
		parse_pri("xpic internal error: canvas: bad area:",area);
		rx=ry=rdx=rdy = 0;   // make gcc happier	
		load_display = subregion = annotate = 0;

	}

	image8 = pr;
	image32 = (DPIXEL32 *) image8;

/* 
	do it
*/
	offset = ry * canvas_size_x + rx;
	if(dsp_depth == 8){
		for(ip8=image8+offset,mip=image16+offset,i=0;i<rdy;i++){
			for(j=0;j<rdx;j++){
				*ip8++ =  mi_lut[*mip++];
			}
			ip8 += canvas_size_x - rdx;
			mip += canvas_size_x - rdx;
		}
	}else{
		for(ip32=image32+offset,mip=image16+offset,i=0;i<rdy;i++){
			for(j=0;j<rdx;j++){
				*ip32++ =  mi_lut[*mip++];
			}
			ip32 += canvas_size_x - rdx;
			mip += canvas_size_x - rdx;
		}
	}
/*
	load images and handle annotation
*/
	display_put_image(rx,ry,rdx,rdy);

	if(load_display){
		display_copy_area(rx,ry,rdx,rdy);
		if(annotate && annotate_exist()){
			if(subregion)display_set_annotate_clip(rx,ry,rdx,rdy);
			annotate_refresh();
			if(subregion)display_clear_annotate_clip();
		}
	}
}

void
refresh(int left,int top,int width,int height)
{
	display_copy_area(left,top,width,height);
	if(annotate_exist()){
		display_set_annotate_clip(left,top,width,height);
		annotate_refresh();
		display_clear_annotate_clip();
	}
}
