/*
command - comamnd dispatching and initialization rotuines
*/

#ident "$Id: command.c,v 1.14 2007/05/22 13:22:45 ccrawford Exp $"

#define INIT_GLOBALS		/* see xpic.h */
#include 	"xpic.h"

struct PROC_TAB clist[] = {
	{"+",cmd_next},
	{"-",cmd_previous},
	{"annotate",cmd_annotate},
	{"box",cmd_box},
	{"browse",cmd_browse},
	{"cd",cmd_cd},
	{"center",cmd_center},
	{"cine",cmd_cine},
	{"clear",cmd_clear},
	{"copyquad",cmd_copyquad},
	{"corner",cmd_corner},
	{"cursor",cmd_cursor},
	{"difference",cmd_difference},
	{"environment",cmd_env},
	{"exit",cmd_exit},
	{"expression",cmd_expression},
	{"file",cmd_file},
	{"flip",cmd_flip},
	{"gamma",cmd_gamma},
	{"halftone",cmd_halftone},
	{"header",cmd_header},
	{"help",cmd_help},
	{"hexant",cmd_hexant},
	{"horizontal",cmd_horizontal},
	{"images",cmd_images},
	{"invert",cmd_invert},
	{"level",cmd_level},
	{"lc",cmd_lc},
	{"log",cmd_log},
	{"ls",cmd_ls},
	{"magnify",cmd_magnify},
	{"measure",cmd_measure},
	{"mouse",cmd_mouse},
	{"nanant",cmd_nanant},
	{"panel",cmd_panel},
	{"quadrant",cmd_quadrant},
	{"offset",cmd_offset},
	{"open",cmd_open},
	{"pause",cmd_pause},
	{"port",cmd_port},
	{"pwd",cmd_pwd},
	{"printer",cmd_printer},
	{"quit",cmd_exit},
	{"refresh",cmd_refresh},
	{"reopen",cmd_reopen},
	{"reset",cmd_reset},
	{"reverse",cmd_reverse},
	{"roi",cmd_roi},
	{"scale",cmd_scale},
	{"scroll",cmd_scroll},
	{"set",cmd_set},
	{"smpte",cmd_smpte},
	{"source",cmd_source},
	{"status",cmd_status},
	{"transpose",cmd_transpose},
	{"vertical",cmd_vertical},
	{"window",cmd_window},
	{"wl",cmd_wl},
	{"write",cmd_write},
	{"zero",cmd_zero},
	{"!",(PROC)cmd_shell}
	};

int ncom = (sizeof(clist) / sizeof(struct PROC_TAB));

void
command(char *s,int src)
{
	int i;
	char *sp; 

	command_src = src;
	words(s,&argc,argv,MAX_CMD_WORDS);
	if(argc == 0)return;

	for(i=0,sp=argv[0];*sp;sp++){
		i += !(isalpha(*sp) || *sp == '+' || *sp == '-');
	}

	if(i == 0){
		if((i=lookup(argv[0],1)) >= 0){
			(*clist[i].func)();
		}
	}else{
		images(s);
	}
}

#ifdef TEST_HELP

int
main(int argc,char **argv)
{
	char s[128];

	if(argc != 2) parse_er("syntax: xpic command");

	ttyout = stdout;

	strcpy(s,"help ");
	strcat(s,argv[1]);

	command(s,0);
	exit(0);
}

#endif
