/*
gamma_table - build table of gamma values for various systems
*/

#ident "$Id: gamma_table.c,v 1.3 2007/05/22 13:22:45 ccrawford Exp $"

#include <netdb.h>
#include "xpic.h"

typedef struct gtbl GTBL;

struct gtbl {
	char *host;
	float gamma;
	GTBL *next;
};

static GTBL *root=NULL;		/* root of table */
static GTBL *last=NULL;		/* last entry in table */

void
gamma_insert(char *host,double gamma)
{
	GTBL *next;
	struct hostent *hostp;

	next = (GTBL *) parse_malloc(sizeof(GTBL));

	if(host != NULL){
		hostp = gethostbyname(host);
		if(hostp == NULL) return;
		host = strcpy(parse_malloc_char(strlen(hostp->h_name)+1),
		          hostp->h_name);

		next->host = parse_malloc_char(strlen(host)+1);
		strcpy(next->host,host);
	}else{
		next->host = NULL;
	}

	next->gamma = gamma;
	next->next = NULL;

	if(root == NULL){
		last = root = next;
	}else{
		last->next = next;
		last = next;
	}
}

void
gamma_match(char *host)
{
	GTBL *p=root;

	while(p != NULL){
		if(p->host == NULL){
			gamma_display = p->gamma;
		}else if(!strcmp(p->host,host)){
			gamma_display = p->gamma;
		}
		p = p->next;
	};
}

#ifdef GAMMA_TABLE_TEST
gamma_print(msg)
char *msg;
{
	GTBL *p=root;

	parse_wtext(msg);

	while(p != NULL){
		printf("%s: %f\n",p->host,p->gamma);
		p = p->next;
	};
}

main()
{
	gamma_print("start");
	gamma_insert("carl",1.0);
	gamma_print("after 1");
	gamma_insert("david",3.4);
	gamma_print("after 2");
	gamma_insert("eric",3.8);
	gamma_print("after 3");
	gamma_match("carl");
	gamma_match("eric");
	gamma_match("xxxx");
}
#endif
