/*
ican - convert to and from inverse-canonical (ican) form (little-endian)
*/

#ident "$Id: ican.c,v 1.4 2007/05/22 13:22:45 ccrawford Exp $"

#include <xpic.h>

#define PUTBYTE(n,k)    (((n) & 0xffL) << (8*(k)))
#define GETBYTE(n,k)    ((n) >> 8*(k) & 0xff)

int 
ican_int(int n)
{
        union{
                int canl;
                char canc[4];
        } u;

        u.canc[0] = GETBYTE(n,0);
        u.canc[1] = GETBYTE(n,1);
        u.canc[2] = GETBYTE(n,2);
        u.canc[3] = GETBYTE(n,3);

        return(u.canl);
}

short 
ican_short(short n)
{
        union{
                short canl;
                char canc[2];
        } u;

        u.canc[0] = GETBYTE(n,0);
        u.canc[1] = GETBYTE(n,1);

        return(u.canl);
}

void 
ican_shortv(short *v,int n)
{
	int i;

	for(i=0;i<n;i++) {
		v[i] = ican_short(v[i]);
	}
}
