/*
line - handle line drawing
*/

#ident "$Id: line.c,v 1.6 2007/05/22 13:22:45 ccrawford Exp $"

#include "xpic.h"

static struct LINE_TAB{
	int x;
	int y;
	int type;	/* 0 = move 1 = line */
	struct LINE_TAB *next;
} *lroot=NULL,*lp,*lpp;

void
line_add(int x,int y,int type)
{
	int px,py;

	if(NULL == (lp = (struct LINE_TAB *)malloc(sizeof(struct LINE_TAB)))){
		fputs("Can't allocate space for line\n",ttyout);
		return;
	}

	lp->x = x;
	lp->y = y;
	lp->type = type;
	lp->next = NULL;

	if(lroot == NULL){
		lroot = lp;
		px = py = 0;
	}else{
		lpp = lroot;
		while(lpp->next != NULL) lpp = lpp->next;
		lpp->next = lp;
		px = lpp->x;
		py = lpp->y;
	}

	if(type){
		display_drawline(px,py,x,y,LINE_HARD);
	}
}

int
line_exist(void)
{
	return(lroot != NULL);
}

void
line_refresh(void)
{
	int px,py;

	lpp = lroot;
	px = py = 0;
	while(lpp != NULL){
		if(lpp->type){
			display_drawline(px,py,lpp->x,lpp->y,LINE_HARD);
		}
		px = lpp->x;
		py = lpp->y;
		lpp = lpp->next;
	}
}

void
line_table_clear(void)
{
	lpp = lroot;
	while(lpp != NULL){
		lp = lpp;
		lpp = lp->next;
		free(lp);
	}
	lroot = NULL;
}
