/*
lm.h - offsets for lm-files
*/

static const char rcsid_lm_h[] = "$Id: lm.h,v 1.5 2004/08/02 18:04:45 ccrawford Exp $";

#ifndef _OFFSETLM_
#define _OFFSETLM_

/*
	stuff needed for compilation in both modes.
*/

/* lm-mode */

#define LM_BAG_TYPE_OFFSET 848658 /* constant offset for bag type (char) */
#define LM_BAG_TYPE_A 'A'   /* char constant for A type bag */
#define LM_BAG_TYPE_B 'B'   /* char constant for B type bag */

/* l3f-mode */

#define LM_DIAG_00_OFFSET 206872	/* 0 degree diagnostic offset */
#define LM_DIAG_45_OFFSET 617548	/* 45 degree diagnostic offset */
#define LM_DIAG_90_OFFSET 1028224	/* 90 degree diagnostic offset */

#define LM_HE_FIRST_DIAG 1438904  /* constant offset for HE first diag */

#define LM_DIAG_LENGTH  1024	/* length of diagnostic header */

/* common */

#define LM_BAG_ID_LENGTH 10 		/* bag id length  */

#ifdef MERLIN
		/* l3f - mode */


#define LM_HE_A_WIDTH  256  /* width constant for A type HE bag */
#define LM_HE_A_HEIGHT 192  /* height constant for A type HE bag */
#define LM_HE_B_WIDTH 256   /* width constant for B type HE bag */
#define LM_HE_B_HEIGHT 192  /* height constant for B type HE bag */

#define LM_LE_A_WIDTH  256  /* width constant for A type LE bag */
#define LM_LE_A_HEIGHT 192  /* height constant for A type LE bag */
#define LM_LE_B_WIDTH 256   /* width constant for B type LE bag */
#define LM_LE_B_HEIGHT 192  /* height constant for B type LE bag */

#define LM_PROJ_WIDTH 256 /* width of a projection image */

#define LM_MAX_SLICES 800 /* maximum number of slices */

#define LM_DEPTH_OFFSET 192432     /* where to find number of slices (int) */
#define LM_HE_FIRST_SLICE 1439928  /* constant offset for HE first slice*/
#define LM_HE_NEXT_SLICE  112052 /* offset of next HE slice rel to prev */
#define LM_LE_FIRST_SLICE 1439928  /* constant offset for LE first slice*/
#define LM_LE_NEXT_SLICE 112052  /* offset of next LE slice rel to prev */

#define LM_PROJ_00_OFFSET 207896  /* 0 degree Projection offset */
#define LM_PROJ_45_OFFSET 618572  /* 45 degree Projection offset */
#define LM_PROJ_90_OFFSET 1029248  /* 90 degree Projection offset */

#define LM_BAG_PHASE_OFFSET 1438898 /* constant offset for bag phase (short) */

#define LM_BAG_ID_OFFSET 1438880 /* constant offset for bag id (char[10]) */

#else
		/* lm - mode */

#define LM_HE_A_WIDTH  214  /* width constant for A type HE bag */
#define LM_HE_A_HEIGHT 117  /* height constant for A type HE bag */
#define LM_HE_B_WIDTH 158   /* width constant for B type HE bag */
#define LM_HE_B_HEIGHT 158  /* height constant for B type HE bag */

#define LM_LE_A_WIDTH  107  /* width constant for A type LE bag */
#define LM_LE_A_HEIGHT 59  /* height constant for A type LE bag */
#define LM_LE_B_WIDTH 79   /* width constant for B type LE bag */
#define LM_LE_B_HEIGHT 79  /* height constant for B type LE bag */

#define LM_PROJ_WIDTH 240 /* width of a projection image */

#define LM_MAX_SLICES 448 /* maximum number of slices */

#define LM_DEPTH_OFFSET 191024     /* where to find number of slices (int) */
#define LM_HE_FIRST_SLICE 848666  /* constant offset for HE first slice*/
#define LM_HE_NEXT_SLICE  62796 /* offset of next HE slice rel to prev */
#define LM_LE_FIRST_SLICE 898786  /* constant offset for LE first slice*/
#define LM_LE_NEXT_SLICE 62796  /* offset of next LE slice rel to prev */

#define LM_PROJ_00_OFFSET 203400  /* 0 degree Projection offset */
#define LM_PROJ_45_OFFSET 418488  /* 45 degree Projection offset */
#define LM_PROJ_90_OFFSET 633576  /* 90 degree Projection offset */

#define LM_BAG_PHASE_OFFSET 848662 /* constant offset for bag phase (short) */

#define LM_BAG_ID_OFFSET 848644 /* constant offset for bag id (char[10]) */

#endif

#endif
