/*
mi - handle mi files 
*/

#ident "$Id: mi.c,v 1.6 2007/05/22 13:22:45 ccrawford Exp $"

#include <xpic.h>

/*
	static buffers
*/
static PARSE_MIHEAD *mihead = NULL;

static
struct {
	PARSE_MIHEAD *mihead;
} envs[ENV_N];

void
mi_push(int e)
{
	envs[e].mihead = mihead;
}

void
mi_pop(int e)
{
	mihead = envs[e].mihead;
}

int 
mi_image(int *nx,int *ny,int image_num,char *label)
{
	int i;

	if(mihead == NULL){
		fputs("mi_image (internal): no mihead\n",ttyout);
		return(-1);
	}

	if(image_num < 1 || image_num > mihead->n){
		fputs("mi_image (internal): image number out of range\n",ttyout);
		return(-1);
	}

	image_num--;
	i = mihead->bptr[image_num] + 1;

	if(-1 == fseek(image_fd,(long) i * 512L,0)){
		fputs("Error in seeking to image\n",ttyout);
		return(-1);
	}

	strncpy(label,mihead->label[image_num],PARSE_MI_LEN_LABEL+1);
	*nx = mihead->ncol[image_num];
	*ny = mihead->nrow[image_num];
	return(0);
}

int
mi_total(void)
{ 
	mihead = parse_omi_fe(image_fd,0,ttyout,0);
	if(mihead == NULL){
		return(-1);
	}else{
		return(mihead->n);
	}
}

void
mi_close(void)
{ 
	if(mihead == NULL){
		fputs("mi_close (internal): no mihead\n",ttyout);
	}else{
		parse_frmi(mihead);
	}
}
