/*
ring - ring buffer routines
*/

#ident "$Id: ring.c,v 1.3 2007/05/22 13:22:45 ccrawford Exp $"

#include "xpic.h"

static char ring[RING_LENGTH];	/*the ring buffer*/
static int first;		/* pointer to first data element*/
static int next;		/*next location to fill*/

void
ring_init(void)
{
	first = next = 0;
}

void
ring_put(char *c,int n)
{
	int i;

	for(i=0;i<n;i++){
		ring[next++] = *c++;
		if(next == RING_LENGTH) next = 0;
		if(next == first){
			fprintf(stderr,"ring buffer overflow\n");
			exit(1);
		}
	}
}

int
ring_length(void)
{
	if(next >= first)
		return(next - first);
	else
		return(next + RING_LENGTH - first);
}

void
ring_get(char *c,int n)
{
	int i;

	if(ring_length() < n){
		fprintf(stderr,"ring buffer underflow\n");
		exit(1);
	}

	for(i=0;i<n;i++){
		*c++ = ring[first++];
		if(first == RING_LENGTH) first = 0;
	}
}
