/*
driver - object-oriented driver to handle plot(5) commmands
*/

#ident "$Id: driver.c,v 1.4 2007/05/22 15:56:27 ccrawford Exp $"

#define OWTOOLKIT_WARNING_DISABLED
#include <stdio.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <parse.h>
#include "xplot.h"

#define MASK 0377

extern FILE *plot_file;
static int a[MCA];		/* args to plot command */

void
driver_reset(pc)
PC *pc;
{
	pc->next = 0;
	pc->CurrentX = pc->CurrentY = 0;	
	pc->LineBufCount = 0;	
}

void
driver(pc,cs,n,w)
PC *pc;
char *cs;
int n,w;
{
	int c,i,j;

	for(j=0;j<n;j++){
		c = *cs++;
		if(pc->cmderr){
			;
		}else if(pc->next > 0){
			if(w && pc->svcmd)putc(c,plot_file);
			*(pc->sp++) = c;
			if(pc->sp - pc->s >= MB)
				parse_err("xplot: s buffer overflow",NULL);
			if(pc->sp - pc->s == 2* pc->next){
				for(i=0,pc->sp=pc->s;i<pc->next;i++){
					a[i] = ((pc->sp[1]&MASK) << 8) 
						| (MASK&pc->sp[0]);
					pc->sp += 2;
				}
				pc->next = -2;
			}
		}else if(pc->next == 0){
			pc->svcmd = w;
			switch(c) {
			case 'm':
			case 'p':
			case 'n':
				pc->next = 2;
				break;
			case 'l':
			case 's':
				pc->next = 4;
				break;
			case 't':
			case 'f':
				pc->next = -1;
				break;
			case 'X':
				pc->next = -1;
				pc->svcmd = 0;
				break;
			case 'e':
				pc->svcmd = 0;
				pc->next = 0;
				erase(pc);
				if(w) fwrite(pc->space_save,
						sizeof(char),9,plot_file);
				break;
			case 'h':
				pc->svcmd = 0;
				pc->next = 0;
				start_hard_copy(0);
				break;
			case 'a':
				pc->next = 6;
				break;
			case 'c':
				pc->next = 3;
				break;
			default:
				pc->next = 0;
				pc->cmderr = 1;
				tell_user("plotdriver: unknown command");
			}
			if(pc->svcmd)putc(c,plot_file);
			pc->sp = pc->s;
			pc->cmd = c;
		}else if(pc->next == -1){
			if(w && pc->svcmd)putc(c,plot_file);
			if(c == '\n'){
				pc->next = -2;
				*(pc->sp) = '\0';
			}else
				*(pc->sp++) = c;
		}

		if(pc->next == -2){
			switch(pc->cmd) {
			case 'm':
				move(pc,a[0],a[1]);
				break;
			case 'n':
				cont(pc,a[0],a[1]);
				break;
			case 'l':
				draw_line(pc,a[0],a[1],a[2],a[3]);
				break;
			case 't':
				label(pc,pc->s);
				break;
			case 'p':
				point(pc,a[0],a[1]);
				break;
			case 's':
				space(pc,a[0],a[1],a[2],a[3]);
				pc->space_save[0] = 's';
				for(i=0;i<8;i++)
					pc->space_save[i+1] = pc->s[i];
				break;
			case 'a':
				arc(pc,a[0],a[1],a[2],a[3],a[4],a[5]);
				break;
			case 'c':
				circle(pc,a[0],a[1],a[2]);
				break;
			case 'f':
				linemod(pc,pc->s);
				break;
			case 'X':
				extension(pc,pc->s);
			}
			pc->next = 0;
		}
	}
}
