/*
xplot.h - include file for xplot
*/

static const char rcsid_xplot_h[] = "$Id: xplot.h,v 1.2 2000/04/18 21:47:52 ccrawford Exp $";

#define MB 520			/* max saved buffer size in driver.c */
#define MCA 20			/* max plot command args in driver.c */

typedef struct{
	int type;		/* 1=main 0=copy */

		/* following args are for driver.c */
	char s[MB];		/* buffer to save partial commands */
	char *sp;		/* pointer to s */
	int cmd;		/* plot command being processed */
	int next;		/* number of bytes to wait for */
	char space_save[9];	/* saved args of space() for erase() */
	int cmderr;		/* bad plot command recv */
	int svcmd;		/* 1=save command in plotfile */

	int mouse;		/* 1=write mouse position */
				/* only works for main menu now */

		/* following args are for main.c */
	Canvas canvas;		/* drawing canvas */
	Window canvas_win;	/* drawable for canvas */
	int gcn;		/* which gc to use */
	int LineBufCount;	/* buffered line count */
	XPoint *LineBuf;	/* points in buffer lines */

		/* global scaling and translation information */
	int	CanvasX,CanvasY;	/* canvas size */
	int	CurrentX,CurrentY;	/* current plotting location */
	float	FactorX,FactorY;	/* scale factors */
	int	BottomX, BottomY;	/* plotting offsets */
	} PC;

PC pc_main;			/* plot context for main window */
int port_num;			/* number for port communication */
char *plot_name;		/* name of plot file */

void notify(void);
void clean_socket(void);
void mouse_send(int x,int y);
void driver_reset(PC *pc);
void driver();
void driver(PC *pc,char *cs,int n,int w);
void move(PC *pc,int x,int y);
void cont(PC *pc,int x,int y);
void draw_line(PC *pc,int x0,int y0,int x1,int y1);
void label(PC *pc,char *s);
void point(PC *pc,int x,int y);
void space(PC *pc,int LowX,int LowY,int HighX,int HighY);
void arc(PC *pc ,int xc,int yc,int xbeg,int ybeg,int xend,int yend);
void circle(PC *pc,int xc,int yc,int r);
void linemod(PC *pc,char *mode);
void extension(PC *pc,char *s);
void tell_user(char *s);
void start_hard_copy(int iso);
void erase(PC *pc);
void openpl(PC *pc);
void closepl(PC *pc);
int establish(void);
void parse(int cargc,char **cargv);
